#
# Rebuild switch:
#  --with integrationtests	enable integration tests (not fully maintained, may fail)
#

# Detect the distribution in use
%global __despace head -n 1 | tr -d '[:space:]' | sed -e 's/[(].*[)]//g'
%global __lower4 cut -c 1-4 | tr '[:upper:]' '[:lower:]'
%global __distfile %([ -f /etc/SuSE-release ] && echo /etc/SuSE-release || echo /etc/redhat-release)
%global __distinit %(sed -e 's/ release .*//' -e 's/\\([A-Za-z]\\)[^ ]*/\\1/g' %{__distfile} | %{__despace} | %{__lower4})
%global __distvers %(sed -e 's/.* release \\([^. ]*\\).*/\\1/' %{__distfile} | %{__despace})
# Identify CentOS Linux and Scientific Linux as rhel
%if "%{__distinit}" == "c" || "%{__distinit}" == "cl" || "%{__distinit}" == "sl" || "%{__distinit}" == "sls"
%global __distinit rhel
%endif
# Dist tag for Fedora is still "fc"
%if "%{__distinit}" == "f"
%global __distinit fc
%endif

# Do a systemd-based build from F-15; otherwise, a sysvinit-based build
%global use_systemd %([ "(" "%{__distinit}" == "fc" -a %{__distvers} -gt 14 ")" -o "(" "%{__distinit}" == "rhel" -a %{__distvers} -gt 6 ")" ] && echo 1 || echo 0)

# With systemd, the runtime directory is /run rather than /var/run
%if %{use_systemd}
%global rundir /run
%else
%global rundir %{_localstatedir}/run
%endif

# rundir (/var/run or /run) is on tmpfs from Fedora 15, RHEL 7
%if %([ "(" "%{__distinit}" == "fc" -a %{__distvers} -gt 14 ")" -o "(" "%{__distinit}" == "rhel" -a %{__distvers} -gt 6 ")" ] && echo 1 || echo 0)
%global rundir_tmpfs 1
%endif

# Use certs in %%{_sysconfdir}/pki/tls/certs if available (FC4, RHEL5 onwards)
%global use_pki %(if [ -d %{_sysconfdir}/pki/tls/certs ]; then echo 1; else echo 0; fi)
%if %{use_pki}
%global pkidir %{_sysconfdir}/pki/tls
%else
%global pkidir %{_datadir}/ssl
%endif

# Use PCRE regex support if we have a new enough version (7.0 onwards)
%global pcre_full_version %(pcre-config --version 2>/dev/null || echo 0.0)
%global pcre_version %(echo %{pcre_full_version} | sed -e 's/\\([0-9]*\\.[0-9]*\\).*/\\1/')
%if %(expr %{pcre_version} '>=' 7.0)
%global use_pcre 1
%endif

# libmemcached >= 0.41 available from F-14 (EL-6 and below have libmemcached 0.31)
%if %([ "(" "%{__distinit}" == "fc" -a %{__distvers} -gt 13 ")" -o "(" "%{__distinit}" == "rhel" -a %{__distvers} -gt 6 ")" ] && echo 1 || echo 0)
%global have_libmemcached 1
%endif

# Do a hardened build where possible
%define _hardened_build 1

#global prever rc3
%global rpmrel 5.0.cf

Summary:		Flexible, stable and highly-configurable FTP server
Name:			proftpd
Version:		1.3.4d
Release:		%{?prever:0.}%{rpmrel}%{?prever:.%{prever}}.%{__distinit}%{__distvers}
License:		GPLv2+
Group:			System Environment/Daemons
URL:			http://www.proftpd.org/
Source0:		ftp://ftp.proftpd.org/distrib/source/proftpd-%{version}%{?prever}.tar.gz
Source1:		proftpd.conf
Source5:		proftpd-welcome.msg
Source9:		proftpd.sysconfig
Source10:		http://www.castaglia.org/proftpd/modules/proftpd-mod-vroot-0.9.2.tar.gz
Source11:		http://www.castaglia.org/proftpd/modules/proftpd-mod-geoip-0.3.tar.gz
# The integration tests require perl(Test::Unit) 0.14, which is the latest release on CPAN
# However, the version in Fedora is 0.25 from sourceforge, which is incompatible with the test suite,
# so we bundle version 0.14 here, purely for use during builds with the integration tests enabled
# (they are disabled by default); it is not included as part of the built package and should therefore
# not fall foul of the rules against library bundling
Source13:		http://search.cpan.org/CPAN/authors/id/C/CL/CLEMBURG/Test-Unit-0.14.tar.gz
Source20:		ftp://ftp.proftpd.org/distrib/source/proftpd-%{version}%{?prever}.tar.gz.asc
Source21:		proftpd-key-A511976A.asc
Patch1:			cap-setuid-bug3945.patch
Patch2:			proftpd.conf-no-memcached.patch
Patch4:			proftpd-1.3.4rc1-mod_vroot-test.patch
Patch5:			proftpd-1.3.4-utf8.patch
Patch14:		proftpd-1.3.4a-bug3720.patch
Patch23:		proftpd-1.3.4c-bug3744.patch
Patch24:		proftpd-1.3.4a-bug3745.patch
Patch25:		proftpd-1.3.4a-bug3746.patch
Patch27:		proftpd-mod-vroot-0.9.2-bug3841.patch
Patch28:		proftpd-1.3.4d-bug3973.patch
Patch29:		proftpd-1.3.4d-bz1044586.patch
Patch30:		proftpd-sftp-dh7680-bug4002.patch
Patch100:		proftpd-1.3.4-mysqlconfig.patch
BuildRoot:		%{_tmppath}/%{name}-%{version}-%{release}-root
Requires(preun):	coreutils, findutils
%if %{use_systemd}
BuildRequires:		systemd-units
Requires(pre):		systemd-sysv, /sbin/chkconfig
Requires(post):		systemd-units
Requires(preun):	systemd-units
Requires(postun):	systemd-units
%else
Requires(post):		/sbin/chkconfig
Requires(preun):	/sbin/service, /sbin/chkconfig
Requires(postun):	/sbin/service
%endif
# Need systemd-units for ownership of /usr/lib/tmpfiles.d directory
%if 0%{?rundir_tmpfs:1}
Requires:		systemd-units
%endif
BuildRequires:		pam-devel, ncurses-devel, pkgconfig, gettext, zlib-devel, gnupg
BuildRequires:		openssl-devel, libacl-devel, libcap-devel, /usr/include/tcpd.h
BuildRequires:		openldap-devel, mysql-devel, postgresql-devel, GeoIP-devel
BuildRequires:		pcre-devel
%if 0%{?have_libmemcached:1}
BuildRequires:		libmemcached-devel >= 0.41
%endif

# Test suite requirements
BuildRequires:		check-devel
%if 0%{?_with_integrationtests:1}
BuildRequires:		perl(Compress::Zlib)
BuildRequires:		perl(IO::Socket::SSL)
BuildRequires:		perl(Net::FTPSSL)
BuildRequires:		perl(Net::SSLeay)
BuildRequires:		perl(Net::Telnet)
BuildRequires:		perl(Test::Harness)
BuildRequires:		perl(Time::HiRes)
%endif

Provides:		ftpserver
Obsoletes:		proftpd-core < %{version}-%{release}, proftpd-standalone < %{version}-%{release}
Provides:		proftpd-core = %{version}-%{release}, proftpd-standalone = %{version}-%{release}
Obsoletes:		proftpd-extras < %{version}-%{release}
Provides:		proftpd-extras = %{version}-%{release}
Obsoletes:		proftpd-tls < %{version}-%{release}
Provides:		proftpd-tls = %{version}-%{release}

# Decide whether to enable POSIX ACL support
# This doesn't work on some old Red Hat distributions that ship broken
# libtool archives in libacl-devel that refer to /lib/libattr.la instead
# of /usr/lib/libattr.la - see README.facl
#
# Note also that mod_facl must be built as a DSO because it will cause problems
# on filesystems without extended attribute support, which cannot be disabled if
# the module is built-in.
%global libacl_la %([ -f /usr/lib64/libacl.la ] && echo /usr/lib64/libacl.la || echo /usr/lib/libacl.la)
%global acl_dep_libs %(grep '^dependency_libs=' %{libacl_la} 2>/dev/null | sed -e "s/.*=' *\\(.*\\)'/\\1/")
%global broken_libacl %([ -n "%{acl_dep_libs}" -a ! -f "%{acl_dep_libs}" ] && echo 1 || echo 0)
%if %{broken_libacl}
%global acl_opts %{nil}
%global acl_mod %{nil}
%else
%global acl_opts --enable-facl
%global acl_mod :mod_facl
%endif

%description
ProFTPD is an enhanced FTP server with a focus toward simplicity, security,
and ease of configuration. It features a very Apache-like configuration
syntax, and a highly customizable server infrastructure, including support for
multiple 'virtual' FTP servers, anonymous FTP, and permission-based directory
visibility.

This package defaults to the standalone behavior of ProFTPD, but all the
needed scripts to have it run by xinetd instead are included.

%package devel
Summary:	ProFTPD - Tools and header files for developers
Group:		Development/Libraries
Requires:	%{name} = %{version}-%{release}
# devel package requires the same devel packages as were build-required
# for the main package
Requires:	gcc, libtool
Requires:	GeoIP-devel
Requires:	libacl-devel
Requires:	libcap-devel
Requires:	mysql-devel
Requires:	openldap-devel
Requires:	openssl-devel
Requires:	pam-devel
Requires:	pcre-devel
Requires:	postgresql-devel
Requires:	pkgconfig
Requires:	ncurses-devel
Requires:	zlib-devel
Requires:	/usr/include/tcpd.h
%if 0%{?have_libmemcached:1}
Requires:	libmemcached-devel >= 0.41
%endif

%description devel
This package is required to build additional modules for ProFTPD.

%package ldap
Summary:	Module to add LDAP support to the ProFTPD FTP server
Group:		System Environment/Daemons
Requires:	%{name} = %{version}-%{release}

%description ldap
Module to add LDAP support to the ProFTPD FTP server.

%package mysql
Summary:	Module to add MySQL support to the ProFTPD FTP server
Group:		System Environment/Daemons
Requires:	%{name} = %{version}-%{release}

%description mysql
Module to add MySQL support to the ProFTPD FTP server.

%package postgresql
Summary:	Module to add PostgreSQL support to the ProFTPD FTP server
Group:		System Environment/Daemons
Requires:	%{name} = %{version}-%{release}

%description postgresql
Module to add PostgreSQL support to the ProFTPD FTP server.

%package utils
Summary:	ProFTPD - Additional utilities
Group:		System Environment/Daemons
Requires:	%{name} = %{version}-%{release}

%description utils
This package contains additional utilities for monitoring and configuring the
ProFTPD server:

* ftpasswd: generate passwd(5) files for use with AuthUserFile
* ftpcount: show the current number of connections per server/virtualhost
* ftpmail: monitor transfer log and send email when files uploaded
* ftpquota: manipulate quota tables
* ftptop: show the current status of FTP sessions
* ftpwho: show the current process information for each FTP session

%prep
gpg --import %{SOURCE21} || :
gpg --verify %{SOURCE20} %{SOURCE0}
%setup -q -n %{name}-%{version}%{?prever} -a 10 -a 11 -a 13

# Copy mod_vroot source, documentation and tests into place
cp -p mod_vroot/mod_vroot.c contrib/
cp -p mod_vroot/mod_vroot.html doc/contrib/
cp -p mod_vroot/t/lib/ProFTPD/Tests/Modules/mod_vroot.pm \
	tests/t/lib/ProFTPD/Tests/Modules/
cp -p mod_vroot/t/modules/mod_vroot.t tests/t/modules/

# Copy mod_geoip source and documentation into place
cp -p mod_geoip/mod_geoip.c contrib/
cp -p mod_geoip/mod_geoip.html doc/contrib/

# If we're running the full test suite, include the mod_vroot test
%patch4 -p1 -b .test_vroot

# Fix character encoding in docs
%patch5 -p1 -b .utf8

# Fix spurious log messages at session close
# http://bugs.proftpd.org/show_bug.cgi?id=3945
%patch1

# Various module logfile permissions are 0600 instead of 0640
# http://bugs.proftpd.org/show_bug.cgi?id=3720
%patch14 -p0

# Support ls(1) -1 option for LIST command
# http://bugs.proftpd.org/show_bug.cgi?id=3744
%patch23 -p0

# Reject PASV command if no IPv4 address available
# http://bugs.proftpd.org/show_bug.cgi?id=3745
%patch24 -p0

# Support applying ListOptions only to NLST or to LIST commands
# http://bugs.proftpd.org/show_bug.cgi?id=3746
%patch25 -p0

# Fix possible symlink race when applying UserOwner to newly created directory
# http://bugs.proftpd.org/show_bug.cgi?id=3841
%patch27

# Fix mod_sftp/mod_sftp_pam invalid pool allocation during kbdint authentication
# http://bugs.proftpd.org/show_bug.cgi?id=3973
%patch28

# Fix support for 8192-bit DH parameters (#1044586)
%patch29

# Add 3072-bit and 7680-bit DH parameters
# http://bugs.proftpd.org/show_bug.cgi?id=4002
%patch30

# Old distros have broken mysql_config scripts: fix up their output
%patch100 -p1 -b .mysql

# Avoid documentation name conflicts
mv contrib/README contrib/README.contrib

# Set up directory names in config file
sed -e 's#@PKIDIR@#%{pkidir}#g' \
	%{SOURCE1} > proftpd.conf

# If we don't have libmemcached support, remove the mod_tls_memcache
# snippet from the config file
%if 0%{!?have_libmemcached:1}
%patch2 -p0
%endif

# Tweak logrotate script for systemd compatibility (#802178)
%if %{use_systemd}
sed -i -e '/killall/s/test.*/systemctl reload proftpd.service/' \
	contrib/dist/rpm/proftpd.logrotate
%endif

# Avoid docfile dependencies
chmod -x contrib/xferstats.holger-preiss

# PAM Configuration:
# Default PAM configuration file uses password-auth common config;
# revert to system-auth if password-auth is not available
if [ ! -f /etc/pam.d/password-auth ]; then
	sed -i -e s/password-auth/system-auth/ contrib/dist/rpm/proftpd.pam
fi
# The "include" syntax used in our PAM configuration file was introduced in
# PAM 0.78 and is therefore supported in FC-5 and EL-5 onwards; older
# distributions such as EL-4 (PAM 0.77) need to fall back to using the
# now-deprecated pam_stack module. Since the pam-devel package doesn't
# include a pkgconfig file from which we could check the version number, we
# instead check for the absence of the file /etc/pam.d/config-util, which is
# present in all PAM packages from 0.80 onwards and acts as a useful
# indicator of the need to fall back to pam_stack.
[ ! -f /etc/pam.d/config-util ] && sed -i -e \
	's/include[[:space:]]*system-auth/required'\ \ \ \ \ 'pam_stack.so service=system-auth/' \
	contrib/dist/rpm/proftpd.pam

# Remove audit modules if not present
[ ! -x /%{_lib}/security/pam_loginuid.so ] &&
	sed -i -e '/[[:space:]]pam_loginuid\.so/d' contrib/dist/rpm/proftpd.pam
[ ! -x /%{_lib}/security/pam_keyinit.so ] &&
	sed -i -e '/[[:space:]]pam_keyinit\.so/d' contrib/dist/rpm/proftpd.pam

# Remove bogus exec permissions from source files
chmod -c -x include/tpl.h lib/tpl.c

%build
# TLS includes (only needed for ancient distributions prior to EL-4)
OPENSSL_INC=""
if OPENSSL_CFLAGS=$(pkg-config --cflags openssl); then
	for i in ${OPENSSL_CFLAGS}; do
		INCPATH=$(echo $i | sed -e 's|-I\([a-z0-9/]*\)|\1|g')
		[ -n ${INCPATH} ] && OPENSSL_INC="${OPENSSL_INC}:${INCPATH}"
	done
fi
# Make sure we can find pcreposix.h
PCRE_INC=""
if [ ! -f /usr/include/pcreposix.h -a -f /usr/include/pcre/pcreposix.h ]; then
	PCRE_INC=":/usr/include/pcre"
fi

%if %{broken_libacl}
echo "Broken libacl.la, not including POSIX ACL support"
%endif

# Modules to be built as DSO's (excluding mod_ifsession, always specified last)
SMOD1=mod_sql:mod_sql_passwd:mod_sql_mysql:mod_sql_postgres
SMOD2=mod_quotatab:mod_quotatab_file:mod_quotatab_ldap:mod_quotatab_radius:mod_quotatab_sql
SMOD3=mod_ldap:mod_ban:mod_wrap:mod_ctrls_admin%{acl_mod}:mod_load:mod_vroot
SMOD4=mod_radius:mod_ratio:mod_rewrite:mod_site_misc:mod_exec:mod_shaper:mod_geoip
SMOD5=mod_wrap2:mod_wrap2_file:mod_wrap2_sql:mod_copy:mod_deflate:mod_ifversion:mod_qos
SMOD6=mod_sftp:mod_sftp_pam:mod_sftp_sql:mod_tls_shmcache%{?have_libmemcached::mod_tls_memcache}

%configure \
			--libexecdir="%{_libexecdir}/proftpd" \
			--localstatedir="%{rundir}/proftpd" \
			--disable-strip \
			--enable-ctrls \
			--enable-dso \
			%{acl_opts} \
			--enable-ipv6 \
%{?have_libmemcached:	--enable-memcache} \
			--enable-nls \
			--enable-openssl \
%{?use_pcre:		--enable-pcre} \
			--enable-shadow \
			--enable-tests \
			--with-libraries="%{_libdir}/mysql" \
			--with-includes="%{_includedir}/mysql${OPENSSL_INC}${PCRE_INC}" \
			--with-modules=mod_readme:mod_auth_pam:mod_tls \
			--with-shared=${SMOD1}:${SMOD2}:${SMOD3}:${SMOD4}:${SMOD5}:${SMOD6}:mod_ifsession

make %{?_smp_mflags}

%install
rm -rf %{buildroot}
make install DESTDIR=%{buildroot} \
	rundir="%{rundir}/proftpd" \
	INSTALL_USER=`id -un` \
	INSTALL_GROUP=`id -gn`
install -D -p -m 640 proftpd.conf	%{buildroot}%{_sysconfdir}/proftpd.conf
install -D -p -m 644 contrib/dist/rpm/proftpd.pam \
					%{buildroot}%{_sysconfdir}/pam.d/proftpd
%if %{use_systemd}
install -D -p -m 644 contrib/dist/rpm/proftpd.service \
					%{buildroot}%{_unitdir}/proftpd.service
%else
install -D -p -m 755 contrib/dist/rpm/proftpd.init.d \
					%{buildroot}%{_sysconfdir}/rc.d/init.d/proftpd
%endif
install -D -p -m 644 contrib/dist/rpm/xinetd \
					%{buildroot}%{_sysconfdir}/xinetd.d/xproftpd
install -D -p -m 644 contrib/dist/rpm/proftpd.logrotate \
					%{buildroot}%{_sysconfdir}/logrotate.d/proftpd
install -D -p -m 644 %{SOURCE5}		%{buildroot}%{_localstatedir}/ftp/welcome.msg
install -D -p -m 644 %{SOURCE9}		%{buildroot}%{_sysconfdir}/sysconfig/proftpd
mkdir -p %{buildroot}%{_localstatedir}/{ftp/{pub,uploads},log/proftpd}
touch %{buildroot}%{_sysconfdir}/ftpusers

# Make sure %%{rundir}/proftpd exists at boot time for systems where it's on tmpfs (#656675)
%if 0%{?rundir_tmpfs:1}
install -d -m 755 %{buildroot}%{_prefix}/lib/tmpfiles.d
install -p -m 644 contrib/dist/rpm/proftpd-tmpfs.conf \
					%{buildroot}%{_prefix}/lib/tmpfiles.d/proftpd.conf
%endif

# Find translations
%find_lang proftpd

%check
# Integration tests not fully maintained - stick to API tests only by default
%if 0%{?_with_integrationtests:1}
# Make sure we can find everything we need
export PERL5LIB=$(pwd)/Test-Unit-0.14/lib
export PROFTPD_TEST_DIR=$(pwd)/tests
ln ftpdctl ftpwho tests/
make check
%else
# API tests should always be OK
if ! make -C tests api-tests; then
	# Diagnostics to report upstream
	cat tests/api-tests.log
	./proftpd -V
	# Fail the build
	false
fi
%endif

%clean
rm -rf %{buildroot}

%if %{use_systemd}
%pre
# SysV-to-systemd migration
if [ $1 -gt 1 -a ! -e %{_unitdir}/proftpd.service -a -e %{_sysconfdir}/rc.d/init.d/proftpd ]; then
	/usr/bin/systemd-sysv-convert --save proftpd &>/dev/null
	/sbin/chkconfig --del proftpd &>/dev/null || :
fi
%endif

%post
%if %{use_systemd}
/bin/systemctl daemon-reload &>/dev/null || :
%endif
if [ $1 -eq 1 ]; then
	# Initial installation
%if ! %{use_systemd}
	/sbin/chkconfig --add proftpd || :
%endif
%if 0%{?fedora} >= 18
	/bin/systemctl preset proftpd.service &>/dev/null || :
%endif
	IFS=":"; cat /etc/passwd | \
	while { read username nu nu gid nu nu nu nu; }; do \
		if [ $gid -lt 100 -a "$username" != "ftp" ]; then
			echo $username >> %{_sysconfdir}/ftpusers
		fi
	done
fi

%preun
if [ $1 -eq 0 ]; then
	# Package removal, not upgrade
%if %{use_systemd}
	/bin/systemctl --no-reload disable proftpd.service &>/dev/null || :
	/bin/systemctl stop proftpd.service &>/dev/null || :
%else
	/sbin/service proftpd stop &>/dev/null || :
	/sbin/chkconfig --del proftpd || :
%endif
	find %{rundir}/proftpd -depth -mindepth 1 |
		xargs rm -rf &>/dev/null || :
fi

%postun
%if %{use_systemd}
/bin/systemctl daemon-reload &>/dev/null || :
%endif
if [ $1 -ge 1 ]; then
	# Package upgrade, not uninstall
%if %{use_systemd}
	/bin/systemctl try-restart proftpd.service &>/dev/null || :
%else
	/sbin/service proftpd condrestart &>/dev/null || :
%endif
else
	# Package removal, not upgrade
%if %{use_systemd}
	/bin/systemctl reload xinetd.service &>/dev/null || :
%else
	/sbin/service xinetd reload &>/dev/null || :
%endif
fi

%files -f proftpd.lang
%defattr(-,root,root,-)
%doc COPYING CREDITS ChangeLog NEWS README
%doc README.DSO README.modules README.IPv6 README.PAM
%doc README.capabilities README.classes README.controls README.facl
%doc contrib/README.contrib contrib/README.ratio
%doc doc/* sample-configurations/
%dir %{_localstatedir}/ftp/
%dir %{_localstatedir}/ftp/pub/
%dir %{rundir}/proftpd/
%config(noreplace) %{_localstatedir}/ftp/welcome.msg
%config(noreplace) %{_sysconfdir}/blacklist.dat
%config(noreplace) %{_sysconfdir}/dhparams.pem
%config(noreplace) %{_sysconfdir}/ftpusers
%config(noreplace) %{_sysconfdir}/logrotate.d/proftpd
%config(noreplace) %{_sysconfdir}/pam.d/proftpd
%config(noreplace) %{_sysconfdir}/proftpd.conf
%config(noreplace) %{_sysconfdir}/sysconfig/proftpd
%config(noreplace) %{_sysconfdir}/xinetd.d/xproftpd
%if %{use_systemd}
%{_unitdir}/proftpd.service
%else
%{_sysconfdir}/rc.d/init.d/proftpd
%endif
%if 0%{?rundir_tmpfs:1}
%{_prefix}/lib/tmpfiles.d/proftpd.conf
%endif
%{_bindir}/ftpdctl
%{_sbindir}/ftpscrub
%{_sbindir}/ftpshut
%{_sbindir}/in.proftpd
%{_sbindir}/proftpd
%{_mandir}/man5/xferlog.5*
%{_mandir}/man8/ftpdctl.8*
%{_mandir}/man8/ftpscrub.8*
%{_mandir}/man8/ftpshut.8*
%{_mandir}/man8/proftpd.8*
%dir %{_libexecdir}/proftpd/
%{_libexecdir}/proftpd/mod_ban.so
%{_libexecdir}/proftpd/mod_ctrls_admin.so
%{_libexecdir}/proftpd/mod_copy.so
%{_libexecdir}/proftpd/mod_deflate.so
%{_libexecdir}/proftpd/mod_exec.so
%if !%{broken_libacl}
%{_libexecdir}/proftpd/mod_facl.so
%endif
%{_libexecdir}/proftpd/mod_geoip.so
%{_libexecdir}/proftpd/mod_ifsession.so
%{_libexecdir}/proftpd/mod_ifversion.so
%{_libexecdir}/proftpd/mod_load.so
%{_libexecdir}/proftpd/mod_qos.so
%{_libexecdir}/proftpd/mod_quotatab.so
%{_libexecdir}/proftpd/mod_quotatab_file.so
%{_libexecdir}/proftpd/mod_quotatab_radius.so
%{_libexecdir}/proftpd/mod_quotatab_sql.so
%{_libexecdir}/proftpd/mod_radius.so
%{_libexecdir}/proftpd/mod_ratio.so
%{_libexecdir}/proftpd/mod_rewrite.so
%{_libexecdir}/proftpd/mod_sftp.so
%{_libexecdir}/proftpd/mod_sftp_pam.so
%{_libexecdir}/proftpd/mod_sftp_sql.so
%{_libexecdir}/proftpd/mod_shaper.so
%{_libexecdir}/proftpd/mod_site_misc.so
%{_libexecdir}/proftpd/mod_sql.so
%{_libexecdir}/proftpd/mod_sql_passwd.so
%{?have_libmemcached:%{_libexecdir}/proftpd/mod_tls_memcache.so}
%{_libexecdir}/proftpd/mod_tls_shmcache.so
%{_libexecdir}/proftpd/mod_vroot.so
%{_libexecdir}/proftpd/mod_wrap.so
%{_libexecdir}/proftpd/mod_wrap2.so
%{_libexecdir}/proftpd/mod_wrap2_file.so
%{_libexecdir}/proftpd/mod_wrap2_sql.so
%exclude %{_libexecdir}/proftpd/*.a
%exclude %{_libexecdir}/proftpd/*.la
%attr(331, ftp, ftp) %dir %{_localstatedir}/ftp/uploads/
%attr(750, root, root) %dir %{_localstatedir}/log/proftpd/

%files devel
%defattr(-,root,root)
%{_bindir}/prxs
%{_includedir}/proftpd/
%{_libdir}/pkgconfig/proftpd.pc

%files ldap
%defattr(-,root,root,-)
%doc README.LDAP contrib/mod_quotatab_ldap.ldif contrib/mod_quotatab_ldap.schema
%{_libexecdir}/proftpd/mod_ldap.so
%{_libexecdir}/proftpd/mod_quotatab_ldap.so

%files mysql
%defattr(-,root,root,-)
%{_libexecdir}/proftpd/mod_sql_mysql.so

%files postgresql
%defattr(-,root,root,-)
%{_libexecdir}/proftpd/mod_sql_postgres.so

%files utils
%defattr(-,root,root,-)
%doc contrib/xferstats.holger-preiss
%{_bindir}/ftpasswd
%{_bindir}/ftpcount
%{_bindir}/ftpmail
%{_bindir}/ftpquota
%{_bindir}/ftptop
%{_bindir}/ftpwho
%{_mandir}/man1/ftpasswd.1*
%{_mandir}/man1/ftpcount.1*
%{_mandir}/man1/ftpmail.1*
%{_mandir}/man1/ftpquota.1*
%{_mandir}/man1/ftptop.1*
%{_mandir}/man1/ftpwho.1*

%changelog
* Thu Dec 19 2013 Paul Howarth <paul@city-fan.org> 1.3.4d-5.0.cf
- Fix support for 8192-bit DH parameters (#1044586)
- Add 3072-bit and 7680-bit DH parameters (upstream bug 4002)

* Sat Sep 14 2013 Paul Howarth <paul@city-fan.org> 1.3.4d-4.0.cf
- Fix mod_sftp/mod_sftp_pam invalid pool allocation during kbdint authentication
  (#1007678, upstream bug #3973, CVE-2013-4359)

* Sun Jul 28 2013 Paul Howarth <paul@city-fan.org> 1.3.4d-3.1.cf
- Systemd detection was broken in F-19 so hardcode it instead

* Wed Jul 17 2013 Paul Howarth <paul@city-fan.org> 1.3.4d-3.0.cf
- Pointless rebuild for Perl 5.18 in Rawhide

* Mon Jun 17 2013 Paul Howarth <paul@city-fan.org> 1.3.4d-2.0.cf
- Fix spurious log messages at session close (upstream bug #3945)

* Sat Jun 15 2013 Paul Howarth <paul@city-fan.org> 1.3.4d-1.0.cf
- Update to 1.3.4d
  - Fixed broken build when using --disable-ipv6 configure option
  - Fixed mod_sql "SQLAuthType Backend" MySQL issues
  - Various other bugs fixed - see NEWS for details
- Drop upstreamed patch for PAM session closing

* Tue Apr 16 2013 Paul Howarth <paul@city-fan.org> 1.3.4c-2.0.cf
- Make sure we can switch back to root before closing PAM sessions so that
  they're closed properly and don't pollute the system logs with dbus reject
  messages (#951728, upstream bug #3929)

* Thu Mar  7 2013 Paul Howarth <paul@city-fan.org> 1.3.4c-1.0.cf
- Update to 1.3.4c
  - Added Spanish translation
  - Fixed several mod_sftp issues, including SFTPPassPhraseProvider,
    handling of symlinks for REALPATH requests, and response code logging
  - Fixed symlink race for creating directories when UserOwner is in effect
  - Increased performance of FTP directory listings
- Drop MySQL password patch, no longer needed
- Drop upstreamed proftpd patch for CVE-2012-6095
- Update patch for bug 3744 to apply against updated proftpd code

* Thu Feb 14 2013 Paul Howarth <paul@city-fan.org> 1.3.4b-6.0.cf
- Rebuilt for https://fedoraproject.org/wiki/Fedora_19_Mass_Rebuild

* Thu Jan 10 2013 Paul Howarth <paul@city-fan.org> 1.3.4b-5.0.cf
- Update patch for CVE-2012-6095 to cover vroot cases

* Mon Jan  7 2013 Paul Howarth <paul@city-fan.org> 1.3.4b-4.0.cf
- Fix possible symlink race when applying UserOwner to newly created directory
  (CVE-2012-6095, #892715, http://bugs.proftpd.org/show_bug.cgi?id=3841)

* Mon Sep 24 2012 Paul Howarth <paul@city-fan.org> 1.3.4b-3.0.cf
- Rebuild for new libmemcached in Rawhide

* Thu Aug 30 2012 Paul Howarth <paul@city-fan.org> 1.3.4b-2.0.cf
- Add support for systemd presets in Fedora 18+ (#850281)

* Wed Aug  1 2012 Paul Howarth <paul@city-fan.org> 1.3.4b-1.0.cf
- Update to 1.3.4b
  - Fixed mod_ldap segfault on login when LDAPUsers with no filters used
  - Fixed sporadic SFTP upload issues for large files
  - Fixed SSH2 handling for some clients (e.g. OpenVMS)
  - New FactsOptions directive; see doc/modules/mod_facts.html#FactsOptions
  - Fixed build errors on Tru64, AIX, Cygwin
  - Lots of bugs fixed - see NEWS for details
- No bzipped tarball release this time, so revert to gzipped one
- Drop patches for fixes included in upstream release

* Sat Jul 21 2012 Paul Howarth <paul@city-fan.org> 1.3.4a-11.0.cf
- Rebuilt for https://fedoraproject.org/wiki/Fedora_18_Mass_Rebuild

* Tue Jul  3 2012 Paul Howarth <paul@city-fan.org> 1.3.4a-10.0.cf
- Move tmpfiles.d file from %%{_sysconfdir} to %%{_prefix}/lib

* Sat Apr 21 2012 Paul Howarth <paul@city-fan.org> 1.3.4a-9.0.cf
- Rebuild for new libmemcached in Rawhide

* Fri Apr 13 2012 Paul Howarth <paul@city-fan.org> 1.3.4a-8.0.cf
- Do hardened (PIE) builds where possible

* Mon Mar 12 2012 Paul Howarth <paul@city-fan.org> 1.3.4a-7.0.cf
- Tweak logrotate script for systemd compatibility (#802178)
- Fix leaked file descriptors for log files (as per bug 3751)

* Sat Mar  3 2012 Paul Howarth <paul@city-fan.org> 1.3.4a-6.0.cf
- Rebuild for new libmemcached in Rawhide

* Tue Feb 28 2012 Paul Howarth <paul@city-fan.org> 1.3.4a-5.0.cf
- Document SELinux configuration for ProFTPD in proftpd.conf (#785443)
- Add support for basic and administrative controls actions using ftpdctl by
  default (#786623)
- Add trace logging directives in proftpd.conf but disable them by default as
  they impair performance
- Fix ftpwho/ftptop not showing command arguments (bug 3714)
- Fix MLSD/MLST fail with "DirFakeUser off" or "DirFakeGroup off" (bug 3715)
- Fix proftpd fails to run with "Abort trap" error message (bug 3717)
- Fix LIST -R can loop endlessly if bad directory symlink exists (bug 3719)
- Fix overly restrictive module logfile permissions (bug 3720)
- Fix mod_memcache segfault on server restart (bug 3723)
- Fix unloading mod_quotatab causes segfault (#757311, bug 3724)
- Fix mod_exec does not always capture stdout/stderr output from executed
  command (bug 3726)
- Fix mod_wrap2 causes unexpected LogFormat %%u expansion for SFTP connections
  (bug 3727)
- Fix mod_ldap segfault when LDAPUsers is used with no optional filters
  (bug 3729)
- Fix DirFakeUser/DirFakeGroup off with name causes SIGSEGV for MLSD/MLST
  commands (bug 3734)
- Fix improper handling of self-signed certificate in client-sent cert list
  when "TLSVerifyClient on" is used (bug 3742)
- Fix random stalls/segfaults seen when transferring large files via SFTP
  (bug 3743)
- Support ls(1) -1 option for LIST command (bug 3744)
- Reject PASV command if no IPv4 address available (bug 3745)
- Support applying ListOptions only to NLST or to LIST commands (bug 3746)
- Support option for displaying symlinks via MLSD using syntax preferred by
  FileZilla (bug 3747)
- Fix mod_ban not closing and reopening the BanLog/BanTable file descriptors
  on restart, causing a file descriptor leak (bug 3751)
- Fix mod_ctrls no longer listening on ControlsSocket after restart (bug 3756)

* Fri Feb 10 2012 Paul Howarth <paul@city-fan.org> 1.3.4a-4.0.cf
- Rebuild for new libpcre in Rawhide

* Mon Jan 16 2012 Paul Howarth <paul@city-fan.org> 1.3.4a-3.0.cf
- Add -utils subpackage for support tools, which means the main package
  no longer requires perl

* Tue Jan 10 2012 Paul Howarth <paul@city-fan.org> 1.3.4a-2.0.cf
- Make mod_vroot a DSO, loaded by default (#772354)
- VRootAlias for /etc/security/pam_env.conf is redundant, so remove it
- Add BanMessage (#772354)
- Add -devel subpackage for building third-party modules

* Fri Nov 11 2011 Paul Howarth <paul@city-fan.org> 1.3.4a-1.0.cf
- Update to 1.3.4a:
  - Fixed mod_load/mod_wrap2 build issues
- Drop now-redundant workaround for building mod_load and mod_wrap2
- Drop upstreamed patch for xinetd config typo

* Thu Nov 10 2011 Paul Howarth <paul@city-fan.org> 1.3.4-1.0.cf
- Update to 1.3.4, addressing the following bugs since 1.3.4rc3:
  - ProFTPD with mod_sql_mysql dies of "Alarm clock" on FreeBSD (bug 3702)
  - mod_sql_mysql.so: undefined symbol: make_scrambled_password with MySQL 5.5
    on Fedora (bug 3669)
  - PQescapeStringConn() needs a better check (bug 3192)
  - Enable OpenSSL countermeasure against SSLv3/TLSv1 BEAST attacks (bug 3704);
    to disable this countermeasure, which may cause interoperability issues
    with some clients, use the NoEmptyFragments TLSOption
  - Support SFTPOption for ignoring requests to modify timestamps (bug 3706)
  - RPM build on CentOS 5.5 (64bit): "File not found by glob" (bug 3640)
  - Response pool use-after-free memory corruption error
    (bug 3711, #752812, ZDI-CAN-1420, CVE-2011-4130)
- Drop upstream patch for make_scrambled_password_323
- Update patch for broken mysql_config scripts on ancient distros
- Use upstream SysV initscript rather than our own
- Use upstream systemd service file rather than our own
- Use upstream PAM configuration rather than our own
- Use upstream logrotate configuration rather than our own
- Use upstream tempfiles configuration rather than our own
- Use upstream xinetd configuration rather than our own

* Thu Oct  6 2011 Paul Howarth <paul@city-fan.org> 1.3.4-0.15.0.cf.rc3
- Add upstream patch to not try make_scrambled_password_323 if the MySQL
  library doesn't export it (#718327, upstream bug 3669); this removes support
  for password hashes generated on MySQL prior to 4.1
- Update MySQL config patch to apply cleanly

* Thu Sep 29 2011 Paul Howarth <paul@city-fan.org> 1.3.4-0.14.0.cf.rc3
- Update to 1.3.4rc3 (see NEWS and RELEASE_NOTES for full details)
  - The mod_ldap configuration directives have changed to a simplified version;
    please read the "Changes" section in README.LDAP for details
  - Support for using RADIUS for authentication SSH2 logins, and for supporting
    the NAS-IPv6-Address RADIUS attribute
  - Automatically disable sendfile support on AIX systems
  - <Limit WRITE> now prevents renaming/moving a file out of the limited
    directory
  - ExtendedLog entries now written for data transfers that time out
- Drop upstreamed patches
- Use new --disable-strip option to retain debugging symbols
- Use upstream LDAP quota table schema rather than our own copy
- Add patch for broken MySQL auth (#718327, upstream bug 3669)
- Remove spurious exec permissions on systemd unit file
- Use presence of /run/lock to determine if systemd is init system

* Tue Sep 27 2011 Paul Howarth <paul@city-fan.org> 1.3.4-0.13.0.cf.rc2
- Use native systemd init from Fedora 15 onwards
- Use /run rather than /var/run if using systemd init

* Fri Aug 26 2011 Paul Howarth <paul@city-fan.org> 1.3.4-0.10.1.cf.rc2
- Fix dist tag for CentOS 6 and Scientific Linux

* Fri Jun  3 2011 Paul Howarth <paul@city-fan.org> 1.3.4-0.10.0.cf.rc2
- Rebuild for new libmemcached in Rawhide

* Tue May 17 2011 Paul Howarth <paul@city-fan.org> 1.3.4-0.9.0.cf.rc2
- Add a number of fixes for bugs reported upstream:
  - Avoid spinning proftpd process if read(2) returns EAGAIN (bug 3639)
  - SITE CPFR/CPTO does not update quota tally (bug 3641)
  - Segfault in mod_sql_mysql if "SQLAuthenticate groupsetfast" used (bug 3642)
  - Disable signal handling for exiting session processes (bug 3644)
  - Ensure that SQLNamedConnectInfos with PERSESSION connection policies are
    opened before chroot (bug 3645)
  - MaxStoreFileSize can be bypassed using REST/APPE (bug 3649)
  - Fix TCPAccessSyslogLevel directive (bug 3652)
  - Segfault with "DefaultServer off" and no matching server for incoming IP
    address (bug 3653)

* Fri Apr  8 2011 Paul Howarth <paul@city-fan.org> 1.3.4-0.8.0.cf.rc2
- Update mod_geoip to 0.3 (update for new regexp API)
- Drop patch for mod_geoip API fix

* Tue Apr  5 2011 Paul Howarth <paul@city-fan.org> 1.3.4-0.7.0.cf.rc2
- Enable mod_memcache and mod_tls_memcache if we have libmemcached >= 0.41
- Drop pcre version requirement to 7.0
- Fix mod_geoip and re-enable it

* Mon Apr  4 2011 Paul Howarth <paul@city-fan.org> 1.3.4-0.6.0.cf.rc2
- Update to 1.3.4rc2 (see NEWS and RELEASE_NOTES for full details)
  - Display messages work properly again
  - Fixes plaintext command injection vulnerability in FTPS implementation
    (bug 3624)
  - Fixes CVE-2011-1137 (badly formed SSH messages cause DoS - bug 3586)
  - Performance improvements, especially during server startup/restarts
  - New modules mod_memcache and mod_tls_memcache for using memcached servers
    for caching information among different proftpd servers and/or across
    sessions (this functionality is not yet enabled in this package)
  - Utilities installed by default: ftpasswd, ftpmail, ftpquota
  - New configuration directives:
    - MaxCommandRate
    - SQLNamedConnectInfo
    - TraceOptions
  - Changed configuration directives:
    - BanOnEvent
    - ExtendedLog
    - LogFormat
    - PathAllowFilter
    - PathDenyFilter
    - SFTPOptions
    - SFTPPAMOptions
    - SQLNamedQuery
    - TLSSessionCache
    - Trace
  - New documentation for ConnectionACLs and utilities (ftpasswd etc.)
- Temporarily drop mod_geoip as it fails to build
- We need pcre 7.3 or later for pcre regex support
- Nobody else likes macros for commands

* Tue Mar  1 2011 Paul Howarth <paul@city-fan.org> 1.3.4-0.5.0.cf.rc1
- Update to 2011-02-28 CVS snapshot
- Drop patches for upstream bug 3595, now included upstream

* Thu Feb 24 2011 Paul Howarth <paul@city-fan.org> 1.3.4-0.4.0.cf.rc1
- Update to 2011-02-23 CVS snapshot
- Use the pcre regex implementation rather than the glibc one, which isn't safe
  with untrusted regexps (http://bugs.proftpd.org/3595, CVE-2010-4051,
  CVE-2010-4052)
- BR: pcre-devel
- Drop upstream patches merged into CVS snapshot patch

* Tue Jan 11 2011 Paul Howarth <paul@city-fan.org> 1.3.4-0.3.0.cf.rc1
- Update mod_vroot to 0.9.2
- Get more of the integration tests working

* Wed Jan  5 2011 Paul Howarth <paul@city-fan.org> 1.3.4-0.2.0.cf.rc1
- Update mod_vroot to 0.9.1
- Add upstream patches making unit tests work on systems where 127.0.0.1
  maps to localhost.localdomain rather than just localhost

* Mon Dec 20 2010 Paul Howarth <paul@city-fan.org> 1.3.4-0.1.0.cf.rc1
- Update to 1.3.4rc1 (see RELEASE_NOTES for full details)
  - Added Japanese translation
  - Many mod_sftp bugfixes
  - Fixed SSL_shutdown() errors caused by OpenSSL 0.9.8m and later
  - Added support for SMTP authentication in ftpmail script
  - Updated fnmatch implementation, using glibc-2.9 version
  - New modules: mod_copy, mod_deflate, mod_ifversion, mod_qos
  - New configuration directives:
    - Protocols
    - ScoreboardMutex
    - SFTPClientAlive
    - WrapOptions
  - Changed configuration directives:
    - BanOnEvent
    - ListOptions
    - LogFormat
    - SFTPOptions
    - TLSOptions
    - UseSendfile
  - Deprecated configuration directives:
    - DisplayGoAway (support for this directive has been removed)
- Add %%check section, running the API tests by default
- BR: check-devel, needed for the API test suite
- Add upstream patch (http://bugs.proftpd.org/3568), modified slightly, to fix
  the API tests
- Optionally run the perl-based integration test suite if the build option
  --with integrationtests is supplied; this is off by default as it is not
  fully maintained and is expected to fail in parts
  (see http://bugs.proftpd.org/3568#c5)
- Bundle perl(Test::Unit) 0.14, needed to run the integration test suite
  (version in Fedora is incompatible later version not from CPAN)
- BR: perl modules Compress::Zlib, IO::Socket::SSL, Net::FTPSSL, Net::SSLeay,
  Net::Telnet, Test::Harness and Time::HiRes if building --with integrationtests
- New DSO modules: mod_copy, mod_deflate, mod_ifversion, mod_qos
- QoS support can be enabled in /etc/sysconfig/proftpd
- Fix up configure script to be able to handle mysql_config scripts in
  ancient distributions that have incompatible output

* Mon Dec 20 2010 Paul Howarth <paul@city-fan.org> 1.3.3d-1.0.cf
- Update to 1.3.3d
  - Fixed sql_prepare_where() buffer overflow (bug 3536)
  - Fixed CPU spike when handling .ftpaccess files
  - Fixed handling of SFTP uploads when compression is used

* Fri Dec 10 2010 Paul Howarth <paul@city-fan.org> 1.3.3c-3.0.cf
- Update mod_vroot to 0.9 (improvements to alias handling)
- Note that the previous default configuration is broken by this change; see
  the new VRootAlias line in proftpd.conf
- Add Default-Stop LSB keyword in initscript (for runlevels 0, 1, and 6)

* Wed Dec  1 2010 Paul Howarth <paul@city-fan.org> 1.3.3c-2.0.cf
- Add /etc/tmpfiles.d/proftpd.conf for builds on Fedora 15 onwards to
  support running with /var/run on tmpfs (#656675)

* Mon Nov  1 2010 Paul Howarth <paul@city-fan.org> 1.3.3c-1.0.cf
- Update to 1.3.3c (#647965)
  - Fixed Telnet IAC stack overflow vulnerability (CVE-2010-4221)
  - Fixed directory traversal bug in mod_site_misc (CVE-2010-3867)
  - Fixed SQLite authentications using "SQLAuthType Backend"
- New DSO module: mod_geoip

* Thu Sep 30 2010 Paul Howarth <paul@city-fan.org> 1.3.3b-2.0.cf
- Rebuild for gcc bug (#634757)

* Fri Sep 10 2010 Paul Howarth <paul@city-fan.org> 1.3.3b-1.0.cf
- Update to 1.3.3b
  - Fixed SFTP directory listing bug
  - Avoid corrupting utmpx databases on FreeBSD
  - Avoid null pointer dereferences during data transfers
  - Fixed "AuthAliasOnly on" anonymous logins

* Fri Jul  2 2010 Paul Howarth <paul@city-fan.org> 1.3.3a-1.0.cf
- Update to 1.3.3a
  - Added Japanese translation
  - Many mod_sftp bugfixes
  - Fixed SSL_shutdown() errors caused by OpenSSL 0.9.8m and later
  - Fixed handling of utmp/utmpx format changes on FreeBSD

* Tue May 18 2010 Paul Howarth <paul@city-fan.org> 1.3.3-1.1.cf
- Fix dist tag for RHEL-6 Beta

* Thu Feb 25 2010 Paul Howarth <paul@city-fan.org> 1.3.3-1.0.cf
- Update to 1.3.3
  - Fix creation of mod_ban whitelists using <Class> and <IfClass> (bug 3389)
  - Fix use of HideFiles none on a per-user basis (bug 3397)

* Mon Feb 15 2010 Paul Howarth <paul@city-fan.org> 1.3.3-0.4.0.cf.rc4
- Update to 1.3.3rc4, addressing many bugs (see NEWS)
- Update PID file location in initscript

* Thu Dec 10 2009 Paul Howarth <paul@city-fan.org> 1.3.3-0.3.0.cf.rc3
- Update to 1.3.3rc3, addressing many bugs (see NEWS) including
  CVE-2009-3555 (SSL/TLS renegotiation)
- Drop upstreamed patches

* Thu Dec 10 2009 Paul Howarth <paul@city-fan.org> 1.3.3-0.2.0.cf.rc2
- Add patch for upstream bug 3307 - all logins treated as anonymous if
  there's an <Anonymous> section in the proftpd.conf
- Add patch for upstream bug 3350 - segfault on auth failures

* Wed Dec  9 2009 Paul Howarth <paul@city-fan.org> 1.3.3-0.1.0.cf.rc2
- Update to 1.3.3rc2
- Drop upstreamed patches
- Add new upstream patch for build with OpenSSL 1.0 beta releases (bug 3349)
- Upstream distribution now includes mod_exec, so drop unbundled source
- New DSO modules:
  - mod_sftp
  - mod_sftp_pam
  - mod_sftp_sql
  - mod_shaper
  - mod_sql_passwd
  - mod_tls_shmcache
- Configure script no longer appends "/proftpd" to --localstatedir option
- New utility ftpscrub for scrubbing the scoreboard file
- Include public key blacklist and Diffie-Hellman parameter files for mod_sftp
  in %%{_sysconfdir}
- Remove IdentLookups from config file - disabled by default now
- Import GPG key before attempting to verify the source
- Dist tag for Rawhide no longer needs special-casing

* Wed Oct 21 2009 Paul Howarth <paul@city-fan.org> 1.3.2b-1.0.cf
- Update to 1.3.2b
  - Fixed regression causing command-line define options not to work (bug 3221)
  - Fixed improper SSL/TLS certificate subjectAltName verification (bug 3275)
  - Use correct cached user values with "SQLNegativeCache on" (bug 3282)
  - Fix slower transfers of multiple small files (bug 3284)
  - Support MaxTransfersPerHost, MaxTransfersPerUser properly (bug 3287)
  - Handle symlinks to directories with trailing slashes properly (bug 3297)
- Drop upstreamed defines patch (bug 3221)

* Thu Sep 17 2009 Paul Howarth <paul@city-fan.org> 1.3.2a-7.0.cf
- Restore backward SRPM compatibility broken by previous change

* Wed Sep 16 2009 Tomas Mraz <tmraz@redhat.com> 1.3.2a-6
- Use password-auth common PAM configuration instead of system-auth

* Mon Sep  7 2009 Paul Howarth <paul@city-fan.org> 1.3.2a-5.0.cf
- Add upstream patch for MLSD with dirnames containing glob chars (#521634)

* Tue Sep  1 2009 Paul Howarth <paul@city-fan.org> 1.3.2a-4.0.cf
- New DSO module: mod_exec (#520214)
- Merge tls subpackage back into main package as per Fedora, since main package
  has OpenSSL dependencies anyway

* Wed Aug 19 2009 Paul Howarth <paul@city-fan.org> 1.3.2a-3.0.cf
- Use mod_vroot to work around PAM/chroot issues (#477120, #506735)

* Fri Jul 31 2009 Paul Howarth <paul@city-fan.org> 1.3.2a-2.0.cf
- Add upstream patch to fix parallel build (http://bugs.proftpd.org/3189)

* Mon Jul  6 2009 Paul Howarth <paul@city-fan.org> 1.3.2a-1.0.cf
- Update to 1.3.2a
- Add patch to reinstate support for -DPARAMETER (upstream bug 3221)
- Drop upstreamed config.h patch
- Drop upstreamed sendfile verbosity patch
- Drop upstreamed CAP_AUDIT_WRITE patch
- Update nostrip patch to support build of mod_wrap2
- Remove mod_cap configuration from proftpd.conf (no longer needed)
- New DSO modules:
  - mod_quotatab_radius
  - mod_wrap2
  - mod_wrap2_file
  - mod_wrap2_sql
- Enable mod_lang/nls support for RFC 2640 (and buildreq gettext)
- Add /etc/sysconfig/proftpd to set PROFTPD_OPTIONS and update initscript to
  use this value so we can use a define to enable (e.g.) anonymous FTP support
  rather than having a huge commented-out section in the config file
- Rewrite config file to remove most settings that don't change upstream
  defaults, and add brief descriptions for all available loadable modules
- Move Umask and IdentLookups settings from server config to <Global> context
  so that they apply to all servers, including virtual hosts (#509251)
- Ensure mod_ifsession is always the last one specified, which makes sure that
  mod_ifsession's changes are seen properly by other modules
- Drop pam version requirement - all targets have sufficiently recent version
- Drop redundant explicit dependency on pam
- Subpackages don't need to own %%{_libexecdir}/proftpd directory
- Don't include %%{_includedir} to --with-includes list for %%configure
- Hack to fix bogus rpath no longer needed
- Merge proftpd-extras into main proftpd package (negligible extra deps)
- Fix provides for proftpd-core and proftpd-standalone
- Simplify quoting in acl_dep_libs macro definition (helps syntax highlighting)
- Just remove everything from /var/run/proftpd on package removal rather than
  trying to %%ghost everything (too many different things could be in there)

* Thu Jun 25 2009 Paul Howarth <paul@city-fan.org> 1.3.2-2.2.cf
- BuildRequire libcap-devel so that we use the system library rather than the
  bundled one, and eliminate log messages like:
  kernel: warning: `proftpd' uses 32-bit capabilities (legacy support in use)
- Don't ship patch backup of mod_cap documentation

* Wed Apr 15 2009 Paul Howarth <paul@city-fan.org> 1.3.2-2.1.cf
- Don't make log entries by default every time a transfer is done using the
  sendfile capability

* Tue Apr  7 2009 Paul Howarth <paul@city-fan.org> 1.3.2-1.1.cf
- Update to SLES-compatible dist tag macros
- Define RPM macros in global context in spec file

* Thu Feb  5 2009 Paul Howarth <paul@city-fan.org> 1.3.2-1.0.cf
- Update to 1.3.2

* Mon Jan 26 2009 Paul Howarth <paul@city-fan.org> 1.3.2-0.3.1.CF.rc4
- Update to 1.3.2rc4
- 2-arg open() patch no longer needed

* Fri Jan 23 2009 Paul Howarth <paul@city-fan.org> 1.3.2-0.3.0.CF.rc3
- Rebuild for new MySQL in Rawhide

* Thu Jan  8 2009 Paul Howarth <paul@city-fan.org> 1.3.2-0.2.0.CF.rc3
- Update to 1.3.2rc3 (fixes security issue #464127)
- Exclude new pkgconfig file, as we already exclude header files
- Similarly, exclude new prxs utility
- Remove no longer needed find-umode_t patch
- Reduce MaxInstances to 20 in line with default Fedora configuration
- Update configuration file with config for mod_ban
- Use Fedora PAM configuration and hack it for old releases instead of
  using an old configuration and hacking it to bring it up to date
- README.mod_wrap no longer included in upstream distribution
- Prevent stripping of binaries so we can get useful debuginfo

* Tue Aug 12 2008 Paul Howarth <paul@city-fan.org> 1.3.1-6.0.CF
- Pass --enable-shadow to also have it available, not just PAM (#378981)
- Add mod_ban support (#457289, Philip Prindeville)
- Tweak dist tag macros to work on current Rawhide with three-part releasenum
- Simplify tcp_wrappers buildreq back again using file-based dependency
- Update configh.patch to apply without fuzz

* Thu Dec 20 2007 Paul Howarth <paul@city-fan.org> 1.3.1-3.0.CF
- Rebuild

* Tue Dec 11 2007 Paul Howarth <paul@city-fan.org> 1.3.1-2.2.CF
- Fix INSTALL_STRIP in %%install rather than %%prep

* Mon Dec 10 2007 Paul Howarth <paul@city-fan.org> 1.3.1-2.1.CF
- Temporarily use conditional tcp_wrappers buildreqs to work around problem
  with mock/yum not finding filename buildreqs
- Rebuild for new openssl/openldap in Rawhide
- Add patch to force inclusion of <signal.h> (if available)  when checking for
  umode_t

* Tue Nov  6 2007 Paul Howarth <paul@city-fan.org> 1.3.1-2.0.CF
- Include openldap schema file for quota support (Fran Taylor, #291891)
- Include FDS compatible LDIF file for quota support (converted)
- Prefix source welcome.msg for consistency

* Mon Oct  8 2007 Paul Howarth <paul@city-fan.org> 1.3.1-1.0.CF
- Update to 1.3.1
- Drop patch for mod_sql_mysql.c as typo now fixed upstream
- Drop Fedora patch for open(), now applied upstream

* Fri Aug 24 2007 Paul Howarth <paul@city-fan.org> 1.3.1-0.2.1.CF.rc3
- Update to 1.3.1rc3 (the only version to fix CVE-2007-2165 (#237533))
- Remove old patches; none are useful anymore apart from the CAP_AUDIT_WRITE
  patch
- Patch sstrncpy.c for config.h not being included (reported upstream #2964)
- Patch mod_sql_mysql.c to fix a typo (already fixed in CVS upstream)
- Exclude new headers, at least until some first 3rd party module shows up
- Clean up old leftover CVS strings from our extra files
- LSB-ize the initscript (#247033)
- Explicitly pass --enable-openssl since configure tells us "(default=no)"
- Include patches to fix open calls with recent glibc versions

* Sun Aug 12 2007 Matthias Saou <http://freshrpms.net/> 1.3.0a-8.1.CF
- Fix logrotate entry to silence error when proftpd isn't running (#246392)

* Thu Aug  9 2007 Paul Howarth <paul@city-fan.org> 1.3.0a-7.1.CF
- Include patch to fix "open" calls with recent glibc
- Clarify license as GNU General Public License version 2 or later (GPLv2+)
- Silence rpmlint's complaint about mixed used of tabs and spaces

* Tue Jun 26 2007 Paul Howarth <paul@city-fan.org> 1.3.0a-5.2.CF
- Add patch to enable mod_cap to retain CAP_AUDIT_WRITE

* Mon Jun 25 2007 Paul Howarth <paul@city-fan.org> 1.3.0a-5.1.CF
- BuildRequire /usr/include/tcpd.h as a distribution-agnostic way of specifying
  tcp_wrappers or tcp_wrappers-devel as needed
- use sed rather than perl for scripted edits
- add audit modules in proftpd.pam where appropriate

* Fri Jun  8 2007 Paul Howarth <paul@city-fan.org> 1.3.0a-4.CF
- Rebuild to work around dependency clashes with Fedora

* Tue Feb  6 2007 Paul Howarth <paul@city-fan.org> 1.3.0a-3.CF
- Patch to fix local user buffer overflow in controls request handling, rhbz
  bug #219938, proftpd bug #2867.
- Fix dist tag for fc7 onwards

* Thu Dec  7 2006 Paul Howarth <paul@city-fan.org> 1.3.0a-2.CF
- Fedora 7 onwards buildreq tcp_wrappers-devel

* Mon Nov 27 2006 Paul Howarth <paul@city-fan.org> 1.3.0a-1.CF
- update to 1.3.0a (addresses CVE-2006-5815: remote code execution in ProFTPD)

* Fri Nov 17 2006 Paul Howarth <paul@city-fan.org> 1.3.0-9.CF
- update cmdbufsize patch so as not to segfault with default config

* Fri Nov 17 2006 Paul Howarth <paul@city-fan.org> 1.3.0-8.CF
- let's remember to sign the packages this time

* Thu Nov 16 2006 Paul Howarth <paul@city-fan.org> 1.3.0-7.CF
- include cmdbufsize patch (#214820, CVE-2006-6171)
- include mod_tls patch (also #214820, CVE-2006-6170)
- don't use evil unversioned obsoletes

* Mon Sep 11 2006 Paul Howarth <paul@city-fan.org> 1.3.0-6.CF
- fix dist tag for development builds

* Tue Aug 15 2006 Paul Howarth <paul@city-fan.org> 1.3.0-5.CF
- fix build in mock:
  don't worry if gpg verify fails (e.g. due to missing key)
  add buildreqs tcp_wrappers and zlib-devel

* Tue Jul  4 2006 Paul Howarth <paul@city-fan.org> 1.3.0-4.CF
- disable sendfile by default since it breaks displaying the download speed in
  ftptop and ftpwho (#196913)
- add commented section about DSO loading to the default proftpd.conf

* Mon Jun  5 2006 Paul Howarth <paul@city-fan.org> 1.3.0-3
- apply patch to mod_ctrls.c to fix ProFTPD bug #2792
  (http://bugs.proftpd.org/show_bug.cgi?id=2792)

* Mon May  1 2006 Paul Howarth <paul@city-fan.org> 1.3.0-2
- silence harmless IPv6 failure message at startup when IPv6 isn't available
- remove all conditional build options - build everything
- build most modules as DSOs in separate packages
- remove explicit conflicts on wu-ftpd, anonftp, and vsftpd to let people
  install more than one ftp daemon (#189023)
- enable ctrls (controls via ftpdctl) and facl (POSIX ACLs)
- remove no longer needed PostgreSQL detection workaround
- use "%%{__make} DESTDIR=..." instead of "%%makeinstall"
- ghost the control socket file too
- enumerate binaries and manpages in %%files list

* Fri Apr 21 2006 Paul Howarth <paul@city-fan.org> 1.3.0-1
- update to 1.3.0 full release
- avoid perl deps from docfiles
- use new pam syntax where appropriate

* Mon Mar 20 2006 Paul Howarth <paul@city-fan.org> 1.3.0-0.rc5.1
- update to RC5

* Thu Mar  2 2006 Paul Howarth <paul@city-fan.org> 1.3.0-0.rc4.1
- update to RC4
- check GPG signature of tarball in %%prep
- fix build on CentOS
- recoded spec file as UTF-8
- fix permissions of %%{_sysconfdir}/xinetd.d/xproftpd
- use (noreplace) for all %%config files

* Tue Nov  1 2005 Paul Howarth <paul@city-fan.org> 1.3.0-0.rc3.1
- update to RC3
- simplify distribution-detection code, not using rpmdb queries

* Fri Oct  7 2005 Paul Howarth <paul@city-fan.org> 1.3.0-0.rc2.2
- major rewrite of spec file, bringing it closer to the Fedora Extras package
- inetd subpackage removed

* Tue Jul 26 2005 Paul Howarth <paul@city-fan.org> 1.3.0-0.rc2.1
- 1.3.0rc2 release
- don't include /home/ftp
- use %%ghost to remove /var/run/proftpd/proftpd.{delay,scoreboard}
  rather than a preun script

* Tue Apr 12 2005 Paul Howarth <paul@city-fan.org>
- 1.3.0rc1 release

* Sun Sep 12 2004 Paul Howarth <paul@city-fan.org>
- 1.2.10 release

* Thu Aug 26 2004 Paul Howarth <paul@city-fan.org>
- tweak to enable mysql module to build properly
- make sure mod_sql is included if an SQL backend is selected

* Wed Jul 14 2004 Paul Howarth <paul@city-fan.org>
- 1.2.10rc3 release.
- moved `configure' from %%prep to %%build
- changed default gid from nogroup to nobody

* Mon Jun 21 2004 Paul Howarth <paul@city-fan.org>
- 1.2.10rc1 release.
- import changes from official spec file

* Sat Nov 01 2003 Paul Howarth <paul@city-fan.org>
- 1.2.9 release.

* Fri Oct 17 2003 Paul Howarth <paul@city-fan.org>
- Move xinetd config file to -inetd subpackage.
- 1.2.9rc3 release.

* Thu Oct 09 2003 Paul Howarth <paul@city-fan.org>
- Include detached signature for source in SRPM.
- 1.2.9rc2p1 release.

* Tue Sep 23 2003 Daniel Roesen <dr@proftpd.org>
- Added "--with ipv6" to enable IPv6 support while building the RPM

* Sun May 25 2003 John Morrissey <jwm@horde.net>
- Permit selection of additional contrib modules when building the RPM
  Submitted by: Ivan F. Martinez <ivanfm@users.sourceforge.net>

* Sat Nov  2 2002 John Morrissey <jwm@horde.net>
- Don't let dangling contrib/README.* symlinks get into the built RPM
- logrotate for xferlog

* Wed Aug 14 2002 John Morrissey <jwm@horde.net>
- Added removal of build leftover directory in %%clean.
  Submitted by: Christian Pelealu <kurisu@mweb.co.id>

* Wed Jul  3 2002 John Morrissey <jwm@horde.net> 1.2.6rc1-1
- 1.2.6rc1 release.

* Sun Jun  9 2002 John Morrissey <jwm@horde.net> 1.2.5-1
- 1.2.5 release.

* Fri May 10 2002 TJ Saunders <tj@castaglia.org>
- Added use of %%defattr to allow build of RPMs by non-root users
  For details see http://bugs.proftpd.org/show_bug.cgi?id=1580

* Mon Mar 05 2001 Daniel Roesen <droesen@entire-systems.com>
- PAM >= 0.72 is now a requirement. Versions before are broken and
  Red Hat provides a PAM update for all RH 6.x releases. See:
  http://www.redhat.com/support/errata/RHSA-2000-120.html
  Thanks to O.Elliyasa <osman@Cable.EU.org> for the suggestion.
  For details see http://bugs.proftpd.org/show_bug.cgi?id=1048
- release: 1.2.1-2

* Thu Mar 01 2001 Daniel Roesen <droesen@entire-systems.com>
- Update to 1.2.1
- release: 1.2.1-1

* Tue Feb 27 2001 Daniel Roesen <droesen@entire-systems.com>
- added "Obsoletes: proftpd-core" to make migration to new RPMs easier.
  Thanks to Sébastien Prud'homme <prudhomme@easy-flying.com> for the hint.
- release: 1.2.0-3

* Mon Feb 26 2001 Daniel Roesen <droesen@entire-systems.com>
- cleaned up .spec formatting (cosmetics)
- fixed CFLAGS (fixes /etc/shadow support)
- included COPYING, CREDITS, ChangeLog and NEWS
- Renamed main package from "proftpd-core" to just "proftpd"
- release: 1.2.0-2

* Wed Feb 14 2001 Daniel Roesen <droesen@entire-systems.com>
- moved Changelog to bottom
- fixed %%pre script /etc/ftpusers generator
- removed /ftp/ftpusers from package management. Deinstalling ProFTPD
  should _not_ result in removal of this file.

* Thu Oct 07 1999 O.Elliyasa <osman@Cable.EU.org>
- Multi package creation.
  Created core, standalone, inetd (&doc) package creations.
  Added startup script for init.d
  Need to make the "standalone & inetd" packages being created as "noarch"
- Added URL.
- Added prefix to make the package relocatable.

* Wed Sep 08 1999 O.Elliyasa <osman@Cable.EU.org>
- Corrected inetd.conf line addition/change logic.

* Sat Jul 24 1999 MacGyver <macgyver@tos.net>
- Initial import of spec.

